diff -ruNp ejudge-2.3.18/userlist-server.c ejudge/userlist-server.c
--- ejudge-2.3.18/userlist-server.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/userlist-server.c	2011-07-11 09:02:04.325277406 +0400
@@ -8958,6 +9385,618 @@ cleanup:
   xfree(xml_text);
 }
 
+static void
+cmd_list_all_users_2(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_list_users_2 *data)
+{
+  FILE *f = 0;
+  char *xml_ptr = 0;
+  size_t xml_size = 0;
+  struct userlist_pk_xml_data *out = 0;
+  size_t out_size = 0;
+  const struct contest_desc *cnts = 0;
+  unsigned char logbuf[1024];
+  ptr_iterator_t iter;
+  const struct userlist_user *u;
+
+  snprintf(logbuf, sizeof(logbuf), "LIST_ALL_USERS_2: %d, %d, %d, %d, %d",
+           p->user_id, data->contest_id, data->group_id, data->offset, data->count);
+
+  if (is_judge(p, logbuf) < 0) return;
+  if (data->contest_id > 0) {
+    if (full_get_contest(p, logbuf, &data->contest_id, &cnts) < 0) return;
+  }
+  if (is_dbcnts_capable(p, cnts, OPCAP_LIST_USERS, logbuf) < 0) return;
+
+  f = open_memstream(&xml_ptr, &xml_size);
+  userlist_write_xml_header(f);
+  iter = default_get_brief_list_iterator_2(data->contest_id, data->group_id, data->data, data->offset, data->count);
+  if (iter) {
+    for (; iter->has_next(iter); iter->next(iter)) {
+      if (!(u = (const struct userlist_user*) iter->get(iter))) continue;
+      userlist_unparse_user_short(u, f, data->contest_id);
+      default_unlock_user(u);
+    }
+  }
+  userlist_write_xml_footer(f);
+  if (iter) iter->destroy(iter);
+  close_memstream(f); f = 0;
+  ASSERT(xml_size == strlen(xml_ptr));
+  out_size = sizeof(*out) + xml_size;
+  out = (struct userlist_pk_xml_data*) xmalloc(out_size);
+  memset(out, 0, out_size);
+  out->reply_id = ULS_XML_DATA;
+  out->info_len = xml_size;
+  memcpy(out->data, xml_ptr, xml_size + 1);
+  xfree(xml_ptr); xml_ptr = 0;
+  enqueue_reply_to_client(p, out_size, out);
+  info("%s -> OK, size = %zu", logbuf, xml_size); 
+  xfree(out); out = 0;
+}
+
+static void
+cmd_get_user_count(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_list_users_2 *data)
+{
+  struct userlist_pk_count out;
+  const struct contest_desc *cnts = 0;
+  unsigned char logbuf[1024];
+  long long count = -1;
+  int r;
+
+  snprintf(logbuf, sizeof(logbuf), "GET_USER_COUNT: %d, %d",
+           p->user_id, data->contest_id);
+
+  if (is_judge(p, logbuf) < 0) return;
+  if (data->contest_id) {
+    if (full_get_contest(p, logbuf, &data->contest_id, &cnts) < 0) return;
+  }
+  if (is_dbcnts_capable(p, cnts, OPCAP_LIST_USERS, logbuf) < 0) return;
+
+  r = default_get_user_count(data->contest_id, data->group_id, data->data, &count);
+  if (r < 0) {
+    err("%s -> database error %d", logbuf, -r);
+    send_reply(p, -ULS_ERR_DB_ERROR);
+    return;
+  }
+  if (count < 0) {
+    err("%s -> invalid value of count %lld", logbuf, count);
+    send_reply(p, -ULS_ERR_DB_ERROR);
+    return;    
+  }
+
+  memset(&out, 0, sizeof(out));
+  out.reply_id = ULS_COUNT;
+  out.count = count;
+  enqueue_reply_to_client(p, sizeof(out), &out);
+  info("%s -> OK, %lld", logbuf, out.count); 
+}
+
+static void
+cmd_list_all_groups_2(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_list_users_2 *data)
+{
+  FILE *fout = 0;
+  char *xml_ptr = 0;
+  size_t xml_size = 0;
+  struct userlist_pk_xml_data *out = 0;
+  size_t out_size = 0;
+  unsigned char logbuf[1024];
+  ptr_iterator_t iter;
+  const struct userlist_group *grp;
+
+  snprintf(logbuf, sizeof(logbuf), "LIST_ALL_GROUPS_2: %d, %d, %d",
+           p->user_id, data->offset, data->count);
+
+  if (is_judge(p, logbuf) < 0) return;
+  if (is_dbcnts_capable(p, NULL, OPCAP_LIST_USERS, logbuf) < 0) return;
+
+  fout = open_memstream(&xml_ptr, &xml_size);
+  userlist_write_xml_header(fout);
+  userlist_write_groups_header(fout);
+  iter = default_get_group_iterator_2(data->data, data->offset, data->count);
+  if (iter) {
+    for (; iter->has_next(iter); iter->next(iter)) {
+      grp = (const struct userlist_group*) iter->get(iter);
+      if (grp) {
+        userlist_unparse_usergroup(fout, grp, "      ", "\n");
+        // plugin_call1(unlock_group, grp);
+      }
+    }
+    iter->destroy(iter); iter = 0;
+  }
+  userlist_write_groups_footer(fout);
+  userlist_write_xml_footer(fout);
+  fclose(fout); fout = 0;
+
+  ASSERT(xml_size == strlen(xml_ptr));
+  out_size = sizeof(*out) + xml_size;
+  out = (struct userlist_pk_xml_data*) xmalloc(out_size);
+  memset(out, 0, out_size);
+  out->reply_id = ULS_XML_DATA;
+  out->info_len = xml_size;
+  memcpy(out->data, xml_ptr, xml_size + 1);
+  xfree(xml_ptr); xml_ptr = 0;
+  enqueue_reply_to_client(p, out_size, out);
+  info("%s -> OK, size = %zu", logbuf, xml_size); 
+  xfree(out); out = 0;
+}
+
+static void
+cmd_get_group_count(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_list_users_2 *data)
+{
+  struct userlist_pk_count out;
+  unsigned char logbuf[1024];
+  long long count = -1;
+  int r;
+
+  snprintf(logbuf, sizeof(logbuf), "GET_GROUP_COUNT: %d", p->user_id);
+
+  if (is_judge(p, logbuf) < 0) return;
+  if (is_dbcnts_capable(p, NULL, OPCAP_LIST_USERS, logbuf) < 0) return;
+
+  r = default_get_group_count(data->data, &count);
+  if (r < 0) {
+    err("%s -> database error %d", logbuf, -r);
+    send_reply(p, -ULS_ERR_DB_ERROR);
+    return;
+  }
+  if (count < 0) {
+    err("%s -> invalid value of count %lld", logbuf, count);
+    send_reply(p, -ULS_ERR_DB_ERROR);
+    return;    
+  }
+
+  memset(&out, 0, sizeof(out));
+  out.reply_id = ULS_COUNT;
+  out.count = count;
+  enqueue_reply_to_client(p, sizeof(out), &out);
+  info("%s -> OK, %lld", logbuf, out.count); 
+}
+
+static void
+cmd_create_user_2(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_create_user_2 *data)
+{
+  unsigned char logbuf[1024];
+  const unsigned char *login_str = data->data;
+  const unsigned char *email_str = login_str + data->login_len + 1;
+  const unsigned char *reg_password_str = email_str + data->email_len + 1;
+  const unsigned char *cnts_password_str = reg_password_str + data->reg_password_len + 1;
+  const unsigned char *cnts_name_str = cnts_password_str + data->cnts_password_len + 1;
+  int user_id = 0;
+  unsigned char random_reg_password_buf[64];
+  int reg_password_len = data->reg_password_len;
+  unsigned char sha1_reg_password_buf[128];
+  int reg_password_method = USERLIST_PWD_PLAIN;
+  const struct contest_desc *cnts = 0;
+  int login_len = data->login_len;
+  unsigned char auto_login_buf[64];
+  const struct userlist_contest *cnts_reg = 0;
+  const struct userlist_group *ul_group = 0;
+  int cnts_password_len = data->cnts_password_len;
+  int cnts_password_method = USERLIST_PWD_PLAIN;
+  unsigned char random_cnts_password_buf[64];
+  unsigned char sha1_cnts_password_buf[64];
+  int cloned_flag = 0;
+  int send_email_flag = data->send_email_flag;
+
+  snprintf(logbuf, sizeof(logbuf), "CREATE_USER_2: %d", p->user_id);
+
+  if (p->user_id < 0) {
+    err("%s -> not authentificated", logbuf);
+    send_reply(p, -ULS_ERR_NO_PERMS);
+    return;
+  }
+  ASSERT(p->user_id > 0);
+  if (is_db_capable(p, OPCAP_CREATE_USER, logbuf) < 0) return;
+
+  if (data->contest_id != 0) {
+    if (contests_get(data->contest_id, &cnts) < 0 || !cnts) {
+      err("%s -> invalid contest %d", logbuf, data->contest_id);
+      send_reply(p, -ULS_ERR_BAD_CONTEST_ID);
+      return;
+    }
+  }
+  if (data->group_id != 0) {
+    ul_group = plugin_call(get_group, data->contest_id);
+    if (!ul_group) {
+      err("%s -> invalid group %d", logbuf, data->group_id);
+      send_reply(p, -ULS_ERR_BAD_GROUP_ID);
+      return;
+    }
+  }
+
+  if (!login_len && cnts && cnts->assign_logins && cnts->login_template) {
+    int serial = 0;
+    int serial_step = 1;
+    int n = 0;
+    if (cnts->login_template_options
+        && sscanf(cnts->login_template_options, "%d%d%n",
+                  &serial, &serial_step, &n) == 2
+        && !cnts->login_template_options[n] && serial_step != 0) {
+      serial -= serial_step;
+    } else {
+      serial = 0;
+      serial_step = 1;
+    }
+    if (dflt_iface->try_new_login) {
+      serial += serial_step;
+      if (default_try_new_login(auto_login_buf, sizeof(auto_login_buf), cnts->login_template, serial, serial_step) < 0) {
+        send_reply(p, -ULS_ERR_DB_ERROR);
+        err("%s -> database error", logbuf);
+        return;
+      }
+    } else {
+      while (1) {
+        serial += serial_step;
+        snprintf(auto_login_buf, sizeof(auto_login_buf), cnts->login_template, serial);
+        if ((user_id = default_get_user_by_login(auto_login_buf)) < 0) break;
+      }
+    }
+    login_str = auto_login_buf;
+    login_len = strlen(login_str);
+  }
+
+  if (!login_len) {
+    err("%s -> empty login", logbuf);
+    send_reply(p, -ULS_ERR_INVALID_LOGIN);
+    return;
+  }
+  if (default_get_user_by_login(login_str) >= 0) {
+    err("%s -> login already exists", logbuf);
+    send_reply(p, -ULS_ERR_LOGIN_USED);
+    return;
+  }
+
+  if (data->random_password_flag) {
+    generate_random_password(16, random_reg_password_buf);
+    reg_password_str = random_reg_password_buf;
+    reg_password_len = strlen(reg_password_str);
+  }
+  if (!reg_password_len) {
+    err("%s -> empty password", logbuf);
+    send_reply(p, -ULS_ERR_INVALID_PASSWORD);
+    return;
+  }
+  if (data->use_sha1_flag) {
+    make_sha1_ascii(reg_password_str, reg_password_len, sha1_reg_password_buf);
+    reg_password_method = USERLIST_PWD_SHA1;
+    reg_password_str = sha1_reg_password_buf;
+    reg_password_len = strlen(reg_password_str);
+  }
+
+  user_id = default_new_user(login_str,
+                             email_str,
+                             reg_password_method,
+                             reg_password_str,
+                             data->is_privileged_flag,
+                             data->is_invisible_flag,
+                             data->is_banned_flag,
+                             data->is_locked_flag,
+                             data->show_login_flag,
+                             data->show_email_flag,
+                             data->read_only_flag,
+                             data->never_clean_flag,
+                             data->simple_registration_flag);
+  if (user_id <= 0) {
+    err("%s -> cannot create user", logbuf);
+    send_reply(p, -ULS_ERR_DB_ERROR);
+    return;
+  }
+
+  if (data->contest_id) {
+    int cnts_flags = 0;
+    if (data->cnts_is_invisible_flag) cnts_flags |= USERLIST_UC_INVISIBLE;
+    if (data->cnts_is_banned_flag) cnts_flags |= USERLIST_UC_BANNED;
+    if (data->cnts_is_locked_flag) cnts_flags |= USERLIST_UC_LOCKED;
+    if (data->cnts_is_incomplete_flag) cnts_flags |= USERLIST_UC_INCOMPLETE;
+    if (data->cnts_is_disqualified_flag) cnts_flags |= USERLIST_UC_DISQUALIFIED;
+    if (default_register_contest(user_id, data->contest_id, data->cnts_status, cnts_flags,
+                                 cur_time, &cnts_reg) < 0) {
+      err("%s -> cannot register user", logbuf);
+      send_reply(p, -ULS_ERR_DB_ERROR);
+      return;
+    }
+  }
+
+  if (cnts && !cnts->disable_team_password) {
+    if (data->cnts_use_reg_passwd_flag) {
+      default_set_team_passwd(user_id, data->contest_id, reg_password_method, reg_password_str,
+                              cur_time, &cloned_flag);
+    } else if (data->cnts_set_null_passwd_flag) {
+      // do nothing...
+    } else {
+      if (data->cnts_random_password_flag) {
+        generate_random_password(16, random_cnts_password_buf);
+        cnts_password_str = random_cnts_password_buf;
+        cnts_password_len = strlen(cnts_password_str);
+      }
+      if (data->cnts_use_sha1_flag) {
+        make_sha1_ascii(cnts_password_str, cnts_password_len, sha1_cnts_password_buf);
+        cnts_password_method = USERLIST_PWD_SHA1;
+        cnts_password_str = sha1_cnts_password_buf;
+        cnts_password_len = strlen(cnts_password_str);
+      }
+      default_set_team_passwd(user_id, data->contest_id, cnts_password_method, cnts_password_str,
+                              cur_time, &cloned_flag);
+    }
+  }
+
+  if (cnts && cnts_name_str && *cnts_name_str) {
+    if (default_set_user_info_field(user_id, data->contest_id,
+                                    USERLIST_NC_NAME, cnts_name_str,
+                                    cur_time, &cloned_flag) < 0) {
+      err("%s -> cannot set user name", logbuf);
+      send_reply(p, -ULS_ERR_DB_ERROR);
+      return;
+    }
+    if (default_set_user_info_field(user_id, 0,
+                                    USERLIST_NC_NAME, cnts_name_str,
+                                    cur_time, &cloned_flag) < 0) {
+      err("%s -> cannot set user name", logbuf);
+      send_reply(p, -ULS_ERR_DB_ERROR);
+      return;
+    }
+  }
+
+  if (ul_group) {
+    if (plugin_call(create_group_member, data->group_id, user_id) < 0) {
+      err("%s -> cannot add user to a group", logbuf);
+      send_reply(p, -ULS_ERR_DB_ERROR);
+      return;
+    }
+  }
+
+  const struct userlist_user *u = 0;
+  if (default_get_user_info_1(user_id, &u) < 0 || !u) {
+    send_reply(p, -ULS_ERR_DB_ERROR);
+    err("%s -> database error", logbuf);
+    return;
+  }
+
+  if (!email_str || !*email_str) send_email_flag = 0;
+  /* FIXME: check other conditions when email is not send */
+
+  if (send_email_flag) {
+    send_registration_email(cnts, u, 0, NULL, 0);
+  }
+
+  if (!send_email_flag || !data->confirm_email_flag) {
+    default_touch_login_time(user_id, 0, cur_time);
+  }
+
+  struct userlist_pk_login_ok out;
+  memset(&out, 0, sizeof(out));
+  out.reply_id = ULS_LOGIN_OK;
+  out.user_id = user_id;
+  enqueue_reply_to_client(p, sizeof(out), &out);
+  info("%s -> OK, %d", logbuf, user_id); 
+}
+
+static void
+cmd_next_user(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_list_users_2 *data)
+{
+  unsigned char logbuf[1024];
+  const struct contest_desc *cnts = 0;
+  int user_id = 0;
+
+  snprintf(logbuf, sizeof(logbuf), "NEXT_USER: %d, %d, %d, %d", p->user_id,
+           data->user_id, data->contest_id, data->group_id);
+
+  if (is_judge(p, logbuf) < 0) return;
+  if (data->contest_id) {
+    if (full_get_contest(p, logbuf, &data->contest_id, &cnts) < 0) return;
+  }
+  if (is_dbcnts_capable(p, cnts, OPCAP_LIST_USERS, logbuf) < 0) return;
+
+  int (*func)(void *, int contest_id, int group_id, int user_id, const unsigned char *filter, int *p_user_id);
+  switch (data->request_id) {
+  case ULS_PREV_USER:
+    func = plugin_func(get_prev_user_id);
+    break;
+  case ULS_NEXT_USER:
+    func = plugin_func(get_next_user_id);
+    break;
+  default:
+    send_reply(p, -ULS_ERR_PROTOCOL);
+    err("%s -> invalid request", logbuf);
+    return;
+  }
+
+  struct userlist_pk_login_ok out;
+  memset(&out, 0, sizeof(out));
+
+  if (!func) {
+    out.reply_id = ULS_LOGIN_OK;
+    out.user_id = 0;
+    enqueue_reply_to_client(p, sizeof(out), &out);
+    info("%s -> not implemented, %d", logbuf, 0); 
+    return;
+  }
+
+  if (func(uldb_default->data, data->contest_id, data->group_id, data->user_id, data->data, &user_id) < 0) {
+    err("%s -> database error", logbuf);
+    send_reply(p, -ULS_ERR_DB_ERROR);
+    return;
+  }
+
+  out.reply_id = ULS_LOGIN_OK;
+  out.user_id = user_id;
+  enqueue_reply_to_client(p, sizeof(out), &out);
+  info("%s -> OK, %d", logbuf, user_id); 
+}
+
+static void
+cmd_list_all_users_3(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_list_users_2 *data)
+{
+  FILE *f = 0;
+  char *xml_ptr = 0;
+  size_t xml_size = 0;
+  struct userlist_pk_xml_data *out = 0;
+  size_t out_size = 0;
+  const struct contest_desc *cnts = 0;
+  unsigned char logbuf[1024];
+  const struct userlist_user *u = 0;
+  bitset_t marked = BITSET_INITIALIZER;
+  int user_id;
+
+  snprintf(logbuf, sizeof(logbuf), "LIST_ALL_USERS_3: %d, %d, %d, %d, %d",
+           p->user_id, data->contest_id, data->group_id, data->offset, data->count);
+
+  if (is_judge(p, logbuf) < 0) return;
+  if (data->contest_id > 0) {
+    if (full_get_contest(p, logbuf, &data->contest_id, &cnts) < 0) return;
+  }
+  if (is_dbcnts_capable(p, cnts, OPCAP_LIST_USERS, logbuf) < 0) return;
+
+  bitset_url_decode(data->data, &marked);
+  f = open_memstream(&xml_ptr, &xml_size);
+  userlist_write_xml_header(f);
+  if (marked.size > 0) {
+    for (user_id = 1; user_id < marked.size; ++user_id) {
+      if (bitset_get(&marked, user_id)) {
+        if (default_get_user_info_4(user_id, data->contest_id, &u) >= 0 && u) {
+          userlist_unparse_user_short(u, f, data->contest_id);
+          default_unlock_user(u);
+        }
+      }
+    }
+  }
+  userlist_write_xml_footer(f);
+  close_memstream(f); f = 0;
+  ASSERT(xml_size == strlen(xml_ptr));
+  out_size = sizeof(*out) + xml_size;
+  out = (struct userlist_pk_xml_data*) xmalloc(out_size);
+  memset(out, 0, out_size);
+  out->reply_id = ULS_XML_DATA;
+  out->info_len = xml_size;
+  memcpy(out->data, xml_ptr, xml_size + 1);
+  xfree(xml_ptr); xml_ptr = 0;
+  enqueue_reply_to_client(p, out_size, out);
+  info("%s -> OK, size = %zu", logbuf, xml_size); 
+  xfree(out); out = 0;
+  bitset_free(&marked);
+}
+
+static void
+cmd_list_all_users_4(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_list_users_2 *data)
+{
+  FILE *f = 0;
+  char *xml_ptr = 0;
+  size_t xml_size = 0;
+  struct userlist_pk_xml_data *out = 0;
+  size_t out_size = 0;
+  const struct contest_desc *cnts = 0;
+  unsigned char logbuf[1024];
+  const struct userlist_user *u = 0;
+  bitset_t marked = BITSET_INITIALIZER;
+  int user_id;
+
+  snprintf(logbuf, sizeof(logbuf), "LIST_ALL_USERS_4: %d, %d, %d, %d, %d",
+           p->user_id, data->contest_id, data->group_id, data->offset, data->count);
+
+  if (is_judge(p, logbuf) < 0) return;
+  if (data->contest_id > 0) {
+    if (full_get_contest(p, logbuf, &data->contest_id, &cnts) < 0) return;
+  }
+  if (is_dbcnts_capable(p, cnts, OPCAP_LIST_USERS, logbuf) < 0) return;
+
+  bitset_url_decode(data->data, &marked);
+  f = open_memstream(&xml_ptr, &xml_size);
+  userlist_write_xml_header(f);
+  if (marked.size > 0) {
+    for (user_id = 1; user_id < marked.size; ++user_id) {
+      if (bitset_get(&marked, user_id)) {
+        if (default_get_user_info_5(user_id, data->contest_id, &u) >= 0 && u) {
+          userlist_real_unparse_user(u, f, USERLIST_MODE_ALL, data->contest_id,
+                                     USERLIST_SHOW_REG_PASSWD | USERLIST_SHOW_CNTS_PASSWD);
+          default_unlock_user(u);
+        }
+      }
+    }
+  }
+  userlist_write_xml_footer(f);
+  close_memstream(f); f = 0;
+  ASSERT(xml_size == strlen(xml_ptr));
+  out_size = sizeof(*out) + xml_size;
+  out = (struct userlist_pk_xml_data*) xmalloc(out_size);
+  memset(out, 0, out_size);
+  out->reply_id = ULS_XML_DATA;
+  out->info_len = xml_size;
+  memcpy(out->data, xml_ptr, xml_size + 1);
+  xfree(xml_ptr); xml_ptr = 0;
+  enqueue_reply_to_client(p, out_size, out);
+  info("%s -> OK, size = %zu", logbuf, xml_size); 
+  xfree(out); out = 0;
+  bitset_free(&marked);
+}
+
+static void
+cmd_get_group_info(
+        struct client_state *p,
+        int pkt_len,
+        struct userlist_pk_map_contest *data)
+{
+  unsigned char logbuf[1024];
+  const struct userlist_group *grp;
+  char *xml_ptr = 0;
+  size_t xml_size = 0;
+  FILE *fout = 0;
+  struct userlist_pk_xml_data *out = 0;
+  size_t out_size;
+
+  snprintf(logbuf, sizeof(logbuf), "GET_GROUP_INFO: %d, %d",
+           p->user_id, data->contest_id);
+
+  if (is_admin(p, logbuf) < 0) return;
+
+  grp = plugin_call(get_group, data->contest_id);
+  if (!grp) {
+    err("%s -> invalid group %d", logbuf, data->contest_id);
+    send_reply(p, -ULS_ERR_BAD_GROUP_ID);
+    return;
+  }
+
+  fout = open_memstream(&xml_ptr, &xml_size);
+  userlist_write_xml_header(fout);
+  userlist_write_groups_header(fout);
+  userlist_unparse_usergroup(fout, grp, "      ", "\n");
+  userlist_write_groups_footer(fout);
+  userlist_write_xml_footer(fout);
+  fclose(fout); fout = 0;
+
+  out_size = sizeof(*out) + xml_size;
+  out = alloca(out_size);
+  memset(out, 0, out_size);
+  out->reply_id = ULS_XML_DATA;
+  out->info_len = xml_size;
+  memcpy(out->data, xml_ptr, xml_size + 1);
+  xfree(xml_ptr); xml_ptr = 0;
+  enqueue_reply_to_client(p, out_size, out);
+  info("%s -> OK, size = %zu", logbuf, xml_size); 
+}
+
 static void (*cmd_table[])() =
 {
   [ULS_REGISTER_NEW] =          cmd_register_new,
@@ -9044,6 +10083,20 @@ static void (*cmd_table[])() =
   [ULS_CREATE_GROUP_MEMBER] =   cmd_create_group_member,
   [ULS_DELETE_GROUP_MEMBER] =   cmd_delete_group_member,
   [ULS_GET_GROUPS] =            cmd_get_groups,
+  [ULS_LIST_ALL_USERS_2] =      cmd_list_all_users_2,
+  [ULS_GET_USER_COUNT] =        cmd_get_user_count,
+  [ULS_LIST_ALL_GROUPS_2] =     cmd_list_all_groups_2,
+  [ULS_GET_GROUP_COUNT] =       cmd_get_group_count,
+  [ULS_PRIV_SET_REG_PASSWD_PLAIN] = cmd_priv_set_passwd_2,
+  [ULS_PRIV_SET_REG_PASSWD_SHA1] = cmd_priv_set_passwd_2,
+  [ULS_PRIV_SET_CNTS_PASSWD_PLAIN] = cmd_priv_set_passwd_2,
+  [ULS_PRIV_SET_CNTS_PASSWD_SHA1] = cmd_priv_set_passwd_2,
+  [ULS_CREATE_USER_2] =         cmd_create_user_2,
+  [ULS_PREV_USER] =             cmd_next_user,
+  [ULS_NEXT_USER] =             cmd_next_user,
+  [ULS_LIST_ALL_USERS_3] =      cmd_list_all_users_3,
+  [ULS_LIST_ALL_USERS_4] =      cmd_list_all_users_4,
+  [ULS_GET_GROUP_INFO] =        cmd_get_group_info,
 
   [ULS_LAST_CMD] 0
 };
@@ -9134,6 +10187,20 @@ static int (*check_table[])() =
   [ULS_CREATE_GROUP_MEMBER] =   check_pk_register_contest,
   [ULS_DELETE_GROUP_MEMBER] =   check_pk_register_contest,
   [ULS_GET_GROUPS] =            check_pk_set_user_info,
+  [ULS_LIST_ALL_USERS_2] =      check_pk_list_users_2,
+  [ULS_GET_USER_COUNT] =        check_pk_list_users_2,
+  [ULS_LIST_ALL_GROUPS_2] =     check_pk_list_users_2,
+  [ULS_GET_GROUP_COUNT] =       check_pk_list_users_2,
+  [ULS_PRIV_SET_REG_PASSWD_PLAIN] = check_pk_set_password,
+  [ULS_PRIV_SET_REG_PASSWD_SHA1] = check_pk_set_password,
+  [ULS_PRIV_SET_CNTS_PASSWD_PLAIN] = check_pk_set_password,
+  [ULS_PRIV_SET_CNTS_PASSWD_SHA1] = check_pk_set_password,
+  [ULS_CREATE_USER_2] =         check_pk_create_user_2,
+  [ULS_PREV_USER] =             check_pk_list_users_2,
+  [ULS_NEXT_USER] =             check_pk_list_users_2,
+  [ULS_LIST_ALL_USERS_3] =      check_pk_list_users_2,
+  [ULS_LIST_ALL_USERS_4] =      check_pk_list_users_2,
+  [ULS_GET_GROUP_INFO] =        check_pk_map_contest,
 
   [ULS_LAST_CMD] 0
 };
